#!/bin/bash

mode=""
mode="install" # comment out this line to uninstall

#context="mimetypes" # this is the correct context
context="apps" # but this context seems to work

# application	ain bmz bsp cache ctx dct dem gcf lmp nav ncf pcf prt tmp vcd vpk
# image			vtf
# model			ani hbx mdl phy vtx vvd
# text			bns cfg fgd lua nut qc rad res smd vbsp vmt vmf vmx
# video			bik

for size in 16 24 32 48
do
 echo "Installing "$size"x"$size"..."

 # clean up any icons installed by previous versions of this script
 for ext in ain ani bik bmz bns bsp cache cfg ctx dct dem fgd gcf hbx lmp lua mdl nav ncf nut pcf phy prt qc rad res smd tmp vbsp vcd vmf vmt vmx vpk vtf vtx vvd
 do
  for mime in application image model text video
  do
   xdg-icon-resource uninstall --noupdate --novendor --mode user --context $context --size $size "icon_"$ext"file_"$size".png" $mime-x-$ext
  done
 done

 if [ "$mode" = "install" ]; then
  # application
  for ext in ain bmz bsp cache ctx dct dem gcf lmp nav ncf pcf prt tmp vcd vpk
  do
   xdg-icon-resource $mode --noupdate --novendor --mode user --context $context --size  $size "icon_"$ext"file_"$size".png" application-x-$ext
  done

  # image
  for ext in vtf
  do
   xdg-icon-resource $mode --noupdate --novendor --mode user --context $context --size $size "icon_"$ext"file_"$size".png" image-x-$ext
  done

  # model
  for ext in ani hbx mdl phy vtx vvd
  do
   xdg-icon-resource $mode --noupdate --novendor --mode user --context $context --size $size "icon_"$ext"file_"$size".png" model-x-$ext
  done

  # text
  for ext in bns cfg fgd lua nut qc rad res smd vbsp vmt vmf vmx
  do
   xdg-icon-resource $mode --noupdate --novendor --mode user --context $context --size $size "icon_"$ext"file_"$size".png" text-x-$ext
  done

  # video
  for ext in bik
  do
   xdg-icon-resource $mode --noupdate --novendor --mode user --context $context --size $size "icon_"$ext"file_"$size".png" video-x-$ext
  done
 fi
done

echo "Updating icon resource..."
xdg-icon-resource forceupdate

if [ "$mode" = "install" ]; then
 echo "Installing mimetypes..."
 xdg-mime install --novendor valve_source.xml
else
 echo "Uninstalling mimetypes..."
 xdg-mime uninstall --novendor valve_source.xml
fi

echo "Updating mimetypes..."
update-mime-database ~/.local/share/mime

echo "Done."
